 import java.awt.*;

public class Swivel extends java.applet.Applet{
	Image cockpit, planet, star;
	int angle = 90;
	Image offScreenImage;
	Graphics offScreenGraphics;
	Point[] stars = new Point[50];
	Image star1, star2, star3, star4, star5;
	Point you = new Point(0, 0);
	Point it = new Point(45, 45);
	double dist;
	
	public void init(){
		cockpit = getImage(getCodeBase(), "Images/Cockpit.gif");
		planet = getImage(getCodeBase(), "Images/Planet.gif");
		this.requestFocus();
		offScreenImage = createImage(size().width, size().height);
		offScreenGraphics = offScreenImage.getGraphics();
		for(int i = 0; i <= 49; i++)
			stars[i] = new Point((int)(Math.random()*1680), (int)(Math.random()*500));
		star1 = getImage(getCodeBase(), "Images/Star1.gif");
		star2 = getImage(getCodeBase(), "Images/Star2.gif");
		star3 = getImage(getCodeBase(), "Images/Star3.gif");
		star4 = getImage(getCodeBase(), "Images/Star4.gif");
		star5 = getImage(getCodeBase(), "Images/Star5.gif");
	}
	
	public void paint(Graphics g){
		offScreenGraphics.setColor(Color.black);
		offScreenGraphics.fillRect(0, 0, size().width, size().height);
		for(int i = 1; i <= 10; i++)
			offScreenGraphics.drawImage(star1, stars[i-1].x, stars[i-1].y, this);
		for(int i = 11; i <= 20; i++)
			offScreenGraphics.drawImage(star2, stars[i-1].x, stars[i-1].y, this);
		for(int i = 21; i <= 30; i++)
			offScreenGraphics.drawImage(star3, stars[i-1].x, stars[i-1].y, this);
		for(int i = 31; i <= 40; i++)
			offScreenGraphics.drawImage(star4, stars[i-1].x, stars[i-1].y, this);
		for(int i = 41; i <= 50; i++)
			offScreenGraphics.drawImage(star5, stars[i-1].x, stars[i-1].y, this);
		offScreenGraphics.drawImage(planet, planetX(), 200, (int)(63/dist*64), (int)(63/dist*64), this);
		offScreenGraphics.drawImage(cockpit, 0, 0, this);
		g.drawImage(offScreenImage, 0, 0, this);
	}
	
	public void update(Graphics g){
		paint(g);
	}
	
	public int planetX(){
		double[] b = rectToPolar(it.x-you.x, it.y-you.y);
		dist = b[0];
		double c = b[1] > (double)180 ? 360-b[1] : b[1];
		double a = c-angle+90;
		double x = 165-a;
		x = x*700/150;
		return (int)x;
	}
		
	public boolean keyDown(Event evt, int key){
		if(key == 1006){
			angle += 5;
			if(angle > 180)
				angle = -175;
			for(int i = 1; i <= 50; i++){
				stars[i-1].x += 5*700/150;
				if(stars[i-1].x > 1680)
					stars[i-1].x = stars[i-1].x-1680;
			}
			repaint();
		} else if(key == 1007){
			angle -= 5;
			if(angle < -175)
				angle = 180;
			for(int i = 1; i <= 50; i++){
				stars[i-1].x -= 5*700/150;
				if(stars[i-1].x < 0)
					stars[i-1].x = 1680 + stars[i-1].x;
			}
			repaint();
		} else if(key == 1004){
			double[] dist = polarToRect(5, angle);
			you.x += (int)dist[0];
			you.y += (int)dist[1];
			repaint();
		} else if(key == 1005){
			double[] dist = polarToRect(5, angle);
			you.x -= (int)dist[0];
			you.y -= (int)dist[1];
			repaint();
		}
		return true;	
	}
	
	public double[] rectToPolar(double right, double up){
		double[] answer = new double[2];
		
		if(right == 0){
			if(up == 0){
				answer[0] = 0;
				answer[1] = 0;
			} else {
				answer[0] = Math.abs(up);
				answer[1] = (up > 0) ? 90 : 270;
			}
		} else {
			if(up == 0){
				answer[0] = Math.abs(right);
				answer[1] = (right > 0) ? 0 : 180;
			} else {
				answer[0] = Math.sqrt(up*up + right*right);
				if(right > 0){
					if(up > 0)
						answer[1] = 180/Math.PI*Math.atan(up/right);
					else answer[1] = 360+180/Math.PI*Math.atan(up/right);
				} else {
					if(up > 0)
						answer[1] = 180+180/Math.PI*Math.atan(up/right);
					else answer[1] = 180+180/Math.PI*Math.atan(up/right);
				}
			}
		}
		return answer;
	}
	
	public double[] polarToRect(double length, double angle){
		double[] answer = new double[2];
		
		answer[0] = length*Math.cos(angle/180*Math.PI);
		answer[1] = length*Math.sin(angle/180*Math.PI);
		
		return answer;
	}
}